#!/usr/bin/python
# -*- coding: utf-8 -*-

# a simple launcher for BGE (BlenderGameEngine)
# by Sandie Sandgreen
# released under GPLv3 or later

import wx
import os

# default resolution
xyres = '1920 1080'
# fullscreen on
fullscr = 1
# the game binary
gamebin = 'start_scene_58'

class BgeLauncher(wx.Frame):

	def __init__(self, *args, **kw):
		super(BgeLauncher, self).__init__(*args, **kw) 
		
		self.InitUI()
		
	def InitUI(self):   
		pnl = wx.Panel(self)
		
		wx.StaticBox(pnl, label='System settings', pos=(5, 5), size=(390, 280))

		self.rb1 = wx.RadioButton(pnl, label='1920x1080', pos=(10, 30), style=wx.RB_GROUP)
		self.rb2 = wx.RadioButton(pnl, label='1366x768', pos=(10, 50))
		self.rb3 = wx.RadioButton(pnl, label='1280x1024', pos=(10, 70))
		self.rb4 = wx.RadioButton(pnl, label='1280x800', pos=(150, 30))
		self.rb5 = wx.RadioButton(pnl, label='1024x768', pos=(150, 50))
		self.rb6 = wx.RadioButton(pnl, label='800x600', pos=(150, 70))
		self.rb7 = wx.RadioButton(pnl, label='1920x1200', pos=(300, 30))
		self.rb8 = wx.RadioButton(pnl, label='2048x1152', pos=(300, 50))
		self.rb9 = wx.RadioButton(pnl, label='640x480', pos=(300, 70))
		self.rb1.Bind(wx.EVT_RADIOBUTTON, self.SetVal1)
		self.rb2.Bind(wx.EVT_RADIOBUTTON, self.SetVal2)
		self.rb3.Bind(wx.EVT_RADIOBUTTON, self.SetVal3)
		self.rb4.Bind(wx.EVT_RADIOBUTTON, self.SetVal4)
		self.rb5.Bind(wx.EVT_RADIOBUTTON, self.SetVal5)
		self.rb6.Bind(wx.EVT_RADIOBUTTON, self.SetVal6)
		self.rb7.Bind(wx.EVT_RADIOBUTTON, self.SetVal7)
		self.rb8.Bind(wx.EVT_RADIOBUTTON, self.SetVal8)
		self.rb9.Bind(wx.EVT_RADIOBUTTON, self.SetVal9)

		cb = wx.CheckBox(pnl, label='fullscreen', pos=(15, 100))
		cb.SetValue(True)
		cb.Bind(wx.EVT_CHECKBOX, self.TogFullscreen)

		btn1 = wx.Button(pnl, label='Exit', pos=(90, 250), size=(60, -1))
		btn1.Bind(wx.EVT_BUTTON, self.OnClose)

		btn2 = wx.Button(pnl, label='Game', pos=(250, 250), size=(60, -1))
		btn2.Bind(wx.EVT_BUTTON, self.OnGame)

		image = wx.Image('logo.png', wx.BITMAP_TYPE_ANY)
		imageBitmap = wx.StaticBitmap(pnl, wx.ID_ANY, wx.BitmapFromImage(image))
		imageBitmap.SetPosition((10, 130))

		self.SetSize((400, 300))
		self.SetTitle('Everglow launcher')
		self.Centre()
		self.Show(True)
		
	def TogFullscreen(self, e):
		global fullscr
		if fullscr == 0:
			fullscr = 1
			return
		else:
			fullscr = 0
			return
		
	def SetVal1(self, e):
		global xyres
		state1 = str(self.rb1.GetValue())
		xyres = '1920 1080'
		print(xyres)
	def SetVal2(self, e):
		global xyres
		state2 = str(self.rb2.GetValue())
		xyres = '1366 768'
		print(xyres)
	def SetVal3(self, e):
		global xyres
		state3 = str(self.rb3.GetValue())
		xyres = '1280 1024'
		print(xyres)
	def SetVal4(self, e):
		global xyres
		state4 = str(self.rb4.GetValue())
		xyres = '1280 800'
		print(xyres)
	def SetVal5(self, e):
		global xyres
		state5 = str(self.rb5.GetValue())
		xyres = '1024 768'
		print(xyres)
	def SetVal6(self, e):
		global xyres
		state6 = str(self.rb6.GetValue())
		xyres = '800 600'
		print(xyres)
	def SetVal7(self, e):
		global xyres
		state8 = str(self.rb7.GetValue())
		xyres = '2048 1152'
		print(xyres)
	def SetVal8(self, e):
		global xyres
		state8 = str(self.rb8.GetValue())
		xyres = '2048 1152'
		print(xyres)
	def SetVal9(self, e):
		global xyres
		state9 = str(self.rb9.GetValue())
		xyres = '640 480'
		print(xyres)

	def OnClose(self, e):
		self.Close(True)	

	def OnGame(self, e):
		# ./start_scene_58 f -f 800 600 32 60
		print(fullscr)
		if fullscr == 0:
			launchparam = './' + gamebin + ' f ' + '-w ' + xyres
		else:
			launchparam = './' + gamebin + ' f ' + '-f ' + xyres
		os.system(launchparam)
		print(launchparam)

def main():
	
	ex = wx.App()
	BgeLauncher(None)
	ex.MainLoop()	

if __name__ == '__main__':
	main() 